require(['config'], function() {
	require([
		'jquery.bootstrap.fileUpload' //파일 업로드가 있는 페이지에서 로딩
	], function($) {
		pageObj.init();
	});
});

// 위시리스트 관리
// #ITP_FORM_POMNG08010_SEARCH_WISH_LIST 위시리스트 마스터 선택
// on('change', function() { })
// 추가/수정 버튼 구현 button: function
//   

/*화면 변수*/
const POMNG08010_GRID_ID = '#ITP_POMNG08010_jqGrid';
const POMNG08010_GRID_LIST = '#ITP_POMNG08010_jqGrid_list';
const POMNG08010_GRID_PAGER = '#ITP_POMNG08010_jqGridPager';
const POMNG08010_GRID_EMPTY = '#ITP_POMNG08010_jqGridEmpty';

 
function onPageInit() {
	fn_proc_btn_auth('POMNG08010');
	
	// 버튼 권한설정
	 
	var combo=$('#ITP_FORM_POMNG08010_SEARCH_WISH_LIST');	
	var brandId=fn_make_user_info.get('brandId'), storeId=fn_make_user_info.get('storeId');
	var wishListMgntArr=[], currentNode=null;
	var wishListMgntNo=null;
	var wishListPopup = function (node) {
		var popFn = function(result) {
			wishListMgntNo=result.wishListMgntNo;
			wishListMgntCall();
		};
		fn_call_popup('biz', 'BIZPOP_WISH_LIST', '#ITP_ASIDE', popFn, {brandId, storeId, currentNode: node}, 'S');
	};
	var wishListMgntCall= function() {
		ajaxGet('/api/pomng/select-wishlist', {brandId, storeId}, function(result) {
			var options=combo.find('option');
			combo.data('changeCheck', true);
			wishListMgntArr=result.selectRows;
			for(var n=options.size()-1;n>0;n++) {
				combo.remove(options.eq(n));
			}
			for(var cur of wishListMgntArr ) {
				$('<option/>', { 'value': cur.wishListMgntNo, 'text': cur.wishListNm }).appendTo(combo);
			}
			
			if(wishListMgntNo) combo.val(wishListMgntNo);
			combo.data('changeCheck', false);
			combo.trigger('change');
		}, 'GET'); 
	}; 
	var grid=makeGrid({
		gridId: POMNG08010_GRID_ID,
		colModel: gridColModel.list,
		multiselect: true,
		rownumbers: false 
	});	

	$('button').each(function() {
		var id = $(this).attr('id');
		$(this).on('click', function() {
			switch (id) {
				case 'ITP_BTN_POMNG08010_SRH'				: search();				break;	// 조회 버튼 클릭
				case 'ITP_BTN_POMNG08010_SAVE'				: save(); 				break;	// 저장 버튼 
				case 'ITP_BTN_POMNG08010_ADD'				: wishListAdd(); 				break;	// 추가 버튼
				case 'ITP_BTN_POMNG08010_EDIT'				: wishListEdit();				break;		// 수정 버튼
				case 'ITP_BTN_POMNG08010_ITEM_DELETE'		: itemDelete();			break;	// 품목삭제 버튼
				case 'ITP_BTN_POMNG08010_ITEM_ADD'			: itemAdd();			break;	// 품목추가 버튼
			}
		});
	});
	const search=function() {
		pageObj.switchScreen('LIST'); 
		ajaxGet('/api/pomng/select-wishlist-item', {brandId, storeId, wishListMgntNo}, function(result) {
			console.log("xxxx call result xxxx", result)
			grid.jqGrid('setGridParam', {data: result.selectRows}).trigger('reloadGrid'); 
			itp_fn_jqgrid_resize(POMNG08010_GRID_ID, POMNG08010_GRID_LIST, 'lg');
			gridStatus(POMNG08010_GRID_ID, 'POMNG08010', '위시리스트를 선택하세요');
		}, 'GET'); 
	};
	const wishListFind= function() {
		console.log("find ", wishListMgntArr, wishListMgntNo )
		for(var cur of wishListMgntArr) if(cur.wishListMgntNo==wishListMgntNo) return cur;
		return null;
	};
	// 위시리스트 추가팝업
	const wishListAdd=function() {
		wishListPopup();
	};
	// 위시리스트 수정팝업
	const wishListEdit=function() {
		if(!currentNode) return itp_fn_modal_alert_ajax("수정할 위시리스트를 선택하세요");
		wishListPopup(currentNode);
	};
	// 품목추가
	const itemAdd=function() {
		if(!currentNode) return itp_fn_modal_alert_ajax("품목추가할 위시리스트를 선택하세요");
		var popFn = function(result) {
			console.log("item add result ==> ", result);
			// 기존등록 데이터
			var exists=[]; 
			for(var cur of grid.getRowData() ) exists.push(cur.brandUnitUnqNo);
			for(var cur of result ) {
				if(exists.indexOf(cur.brandUnitUnqNo)==-1 ) {
					cur['viewCd'] = "C";
					console.log("add ======= ", cur)
					grid.jqGrid('addRowData', cur.brandUnitUnqNo, cur, 'last');
				}
			}
			gridStatus(POMNG08010_GRID_ID, 'POMNG08010', '위시리스트를 선택하세요');
		}; 
		fn_call_popup('biz', 'BIZPOP_ITEM', '#ITP_ASIDE', popFn, {brandId,storeId}, 'S'); 
	};
	// 품목삭제
	const itemDelete=function() {
		alert("품목삭제 클릭")
	};

	combo.on('change', function() {
		if(combo.data('changeCheck')) return;
		wishListMgntNo=$(this).val();
		currentNode=wishListFind();
		search();
	});
	wishListMgntCall();		
}
 

/*화면 Grid ColModel*/
const gridColModel = {
	list: [
		{
			index: 'BRAND_ID', name: 'brandId',
			label: ITP_MSG_LOCALE.label.brandId,
			width: 0, fixed: false, align: 'center',
			sortable: false, hidden: true
		},
		{
			index: 'ITEM_NO', name: 'itemId',
			label: '품목번호',
			width: 150, minwidth:200, fixed: false, align: 'center',
			sortable: false, hidden: false
		},
		{
			index: 'ITEM_CLASS_NM', name: 'itemNm',
			label: '품목명',
			width: 200, minwidth:350, fixed: false, align: 'left',
			sortable: false, hidden: false, classes: 'ui-ellipsis'
		},
		{
			index: 'UNIT', name: 'unit',
			label: '단위', 
			width: 80, minwidth:100, fixed: false, align: 'center'
		},  
		{
			index: 'UNIT', name: 'unitAmt',
			label: '단가', 
			width: 150, minwidth:150, fixed: false, align: 'right',
			sortable: false, hidden: false,
			formatter: 'integer', formatoptions: {thousandsSeparator: ','}
		}
	]
};

/*화면공통 Object*/
let pageObj = {
	init: function () {
		onPageInit();
	}, 
	switchScreen: function(mode) {
		$('.itp_det_head').find('button[id^="ITP_BTN_POMNG08010_"]').each(function(i) {
			$(this).hide();
		});
		$('#ITP_TAB_POMNG08010').find('div[id$="_CONTAINER"]').each(function(i) {
			$(this).hide();
		});
		if(mode == 'LIST') { // 목록
			//itp_fn_fire_window_resize();
			$('#ITP_AJAX_POMNG08010_LIST_CONTAINER').show();
			$('#ITP_BTN_POMNG08010_SAVE').show();
			$('#ITP_BTN_POMNG08010_ADD').show();
			$('#ITP_BTN_POMNG08010_VIEW').show();
			$('#ITP_BTN_POMNG08010_ITEM_DELETE').show();
			$('#ITP_BTN_POMNG08010_ITEM_ADD').show();
			fn_show_btn_auth_array(['#ITP_BTN_POMNG08010_SRH', '#ITP_BTN_POMNG08010_DELETE']);
		 
		}
	}, 
};

 